HeapPreview = {};
HeapPreview.modDir = g_currentModDirectory;
HeapPreview.settingsDir = getUserProfileAppPath().. "modSettings/HeapPreview/";
--fix player 10.01.2021 (join a player LS19) by HappyLooser
HeapPreview.metadata = {
	interface = " FS22 ...",
	title = "HeapPreview",
	notes = " Zeigt Aktuelle Fruchtart/Volumen von Haufen an",
	author = " (by HappyLooser)",
	version = " v0.81 Beta",	
	datum = " 24.11.2016",
	update = " 28.12.2021",
	web = " http://modhoster.de",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe: http://modhoster.de"
};

function HeapPreview:loadMap(name)		
	print("---loading ".. tostring(HeapPreview.metadata.title).. tostring(HeapPreview.metadata.version).. tostring(HeapPreview.metadata.author).. "---")
	if not HeapPreview:getServer() then	
		HeapPreview.hlDebugMode = false;
		loadScripts(1);
		hpSetGet:generateDisplay();		
		HeapPreview:loadSettings();
		loadScripts(2);
		FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, HeapPreview.registerActionEventsPlayer);
		Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, HeapPreview.onStartMission);
	end;
end;

function HeapPreview:onStartMission()	
	if not HeapPreview:getServer() then 
		HeapPreview:searchOtherMods();
		hpHlGui:generate(true);		
		if HeapPreview.values.foundMoh then hpSetGetForMoh:loadPdaIcons();hpSetGetForMoh:loadCmds();end;
	end;
end;

function HeapPreview:deleteMap()
	if HeapPreview:getServer() then return;end;
	HeapPreview:saveSettings();
end;

function HeapPreview:registerActionEventsPlayer() 
	local isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'HPOnOffMouseCursor', self, HeapPreview.actionKeyMouse ,false ,true ,false ,true);    
	if isOkay then g_inputBinding.events[eventName].displayIsVisible = false;end;	
end;

function HeapPreview:actionKeyMouse(actionName, keyStatus, arg4, arg5, arg6)	
	if not g_currentMission.hl.dragDrop.on then
		if not HeapPreview.values.isOn and actionName == "HPOnOffMouseCursor" then 
			hpMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true, true); 
		elseif actionName == "HPOnOffMouseCursor" then
			hpMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false, true);		
		end;
	end;
end;

function HeapPreview:mouseEvent(posX, posY, isDown, isUp, button)
	if HeapPreview:getServer() or HeapPreview:get_hl("getIngameMap", {}, "getIngameMap") or HeapPreview:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	if HeapPreview.values.isOn then hpMouseKeyEvents:setKeyMouse(nil, nil, nil, nil, posX, posY, isDown, isUp, button);end;
end;

function HeapPreview:keyEvent(unicode, sym, modifier, isDown)
	if HeapPreview:getServer() or HeapPreview:get_hl("getIngameMap", {}, "getIngameMap") or HeapPreview:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	if HeapPreview.values.isOn then hpMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);end;
end;

function HeapPreview:update(dt)	
	if HeapPreview:getServer() or HeapPreview:get_hl("getIngameMap", {}, "getIngameMap") or HeapPreview:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	g_currentMission.hl.update_timers(dt, "HeapPreview");
	g_currentMission.hl.updateRunMsg(dt, "HeapPreview");
	if g_currentMission.hl.isMouseCursor then g_currentMission.hl.mouseOnOff(true,true, "HeapPreview");end;
	if not HeapPreview.values.isOn then return;end;
	if not HeapPreview.values.onlyMoh or (HeapPreview.values.onlyMoh and not HeapPreview.values.foundMoh) then 
		hpSetGet:searchHeaps();
		if HeapPreview.values.foundHeap then
			hpSetGet:showInfoBoxOrText(true);
		else
			hpSetGet:showInfoBoxOrText(false);		
		end;
	end;
end;

function HeapPreview:draw(dt)
	if HeapPreview:getServer() or HeapPreview:get_hl("getIngameMap", {}, "getIngameMap") or HeapPreview:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	HeapPreview:get_hl("drawRunMsg", {"HeapPreview"}, "HeapPreview:draw");
	if HeapPreview.values.isOn and HeapPreview.values.viewDebugCircle then setDebugCircle();end;
end;	
addModEventListener(HeapPreview);

function HeapPreview:searchOtherMods()	
	local env = getfenv(0);		
	if env["MultiOverlayV4"] ~= nil and env["MultiOverlayV4"] ~= nil then
		HeapPreview.values.moh = env["MultiOverlayV4"];		
	end;
	if g_currentMission.multiOverlayV4 ~= nil then HeapPreview.values.foundMoh = true;else HeapPreview.values.foundMoh = false;end;
end;

function loadScripts(int)
	if int == 1 then
		source(HeapPreview.modDir.."_hl.lua");
		source(HeapPreview.modDir.."defaultSettings/hpLoadTables.lua");
		source(HeapPreview.modDir.."defaultSettings/hpSetGetSettingsXml.lua");
		source(HeapPreview.modDir.."scripte/hpSetGet.lua");
	end;
	if int == 2 then
		source(HeapPreview.modDir.."scripte/mouseKeyEvents/hpMouseKeyEvents.lua");
		source(HeapPreview.modDir.."scripte/mohFeatures/hpSetGetForMoh.lua");
		source(HeapPreview.modDir.."scripte/mouseKeyEvents/hpMouseKeyEvents.lua");
		source(HeapPreview.modDir.."scripte/hlGui/hpHlGui.lua");
	end;
end;

function setDebugCircle()
	if g_currentMission.player == nil or g_currentMission.player.rootNode == nil then return;end; --MP Join Event
	if g_currentMission.controlledVehicle ~= nil then return;end;	
end;

function HeapPreview:getServer()
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;	
end;

function HeapPreview:saveSettings()
	hpSetGetSettingsXml:saveConfig();	
end;

function HeapPreview:loadSettings()
	hpSetGetSettingsXml:loadConfig();	
end;

--_hl Freeware ls17,19,22--
function HeapPreview:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if HeapPreview.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" and g_currentMission.hl[args] ~= nil then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if HeapPreview.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if HeapPreview.hlDebugMode and (not isOkay or foundArgsError) then g_currentMission.hl.setDebug("HeapPreviewMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;
--_hl Freeware ls17,19,22--
